.model small
.stack 100h
.data
	naujalinija              db 13, 10, '$'
    
    KomandLin     	db 256 dup(?)
    argc            dw 0
    argv            dw 256 dup(?)
    
    LinNrBuff     	db 8 dup('0')
    LinNrBuffEnd  	db ' $'
    Handlas         dw ?

    AtdError       	db ': Neisejo atidaryti failo arba neegzistuoja.$'
    SkaitError      db ': Neisejo skaityti failo!$'
    TusciasError    db ': Failas yra tuscias!$'

    Bufferis        db 1024 dup (?)
    Syntaxas        db 13, 10, 9, 'dump [/?] - pagalbos pranesimas', 13, 10, 10, 9, 'dump [failo pavadinimas] - failo sesioliktainis dumpas', 13, 10, '$'
    arg_nr          dw 0
    CharSkait       dw 0
    DabarPozic 		dw 0
    hex             dw 16
    trys            dw 3
    charcountas     dw 0
.code

main proc far
	mov 	dx, @data       ; perkelti data segmenta i registra ax
	mov 	ds, dx          ; nustatyti ds rodyti i data segmenta

	call SkaitArgum  		;ieskom argumentu
    cmp argc, 0
    je PrintinamNaud
	
toliau:									;ieškom kito argumento
    mov si, [arg_nr]
    add si, si		;didina vienetu

    mov bp, argv[si]
    cmp byte ptr ds:[bp], '/'
    jne AtdFaila
    cmp byte ptr ds:[bp+1], '?'
    je PrintinamNaud
	

AtdFaila:
    call SkaitFaila
    mov  CharSkait, ax
    call UzdFaila

    call HexDumpas
    inc arg_nr
	
    mov ax, arg_nr
    cmp ax, argc
    jne toliau
    jmp exit

	
PrintinamNaud:
    lea dx, Syntaxas
    mov ah, 09h
    int 21h	

	
exit:    
    mov ax, 4C00h
    int 21h
	
main endp
;=========Skaitom argumentus==========================================	
	
SkaitArgum proc
    mov ax, @data
    mov es, ax
    
    mov ah, 62h
    int 21h
    
    mov ds, bx
    
    xor cx, cx
    mov cl, ds:[80h]
    lea di, KomandLin
    mov si, 80h+1
    
    cld    
    rep movsb
    
    mov cl, ds:[80h]
    
    mov ax, @data
    mov ds, ax

    xor si, si    
    xor bp, bp  ; argumentu counter'is
    
    mov al, ' '
    lea di, KomandLin
RastArgum:
    repne scasb ; Rast tarpa
    jcxz KomandLinPabaig
    mov [argv+si], di
    dec di
    mov byte ptr [di], 0 ; tarpas -> NULLBYTE
    add si, 2
    inc bp
    jmp RastArgum
KomandLinPabaig:    
    mov [argc], bp
    ret
SkaitArgum endp

;=======Skaitom faila=================================================
	
SkaitFaila proc
    lea dx, ds:bp
    mov al, 2         ;Skaitom ir rasom
    mov ah, 3Dh      
    int 21h
    mov Handlas, ax
    jc ErrorAtidarant
    jmp BeErrorAtidarant
	
ErrorAtidarant:
    call PrintinamPavad
    lea dx, AtdError
    mov ah, 09h
    int 21h
	
    mov ax,4C01h      ; error nr.1
    int 21h
	
BeErrorAtidarant:
    lea dx, Bufferis
    mov bx, Handlas
    mov cx, 1024
    mov ah, 3Fh    
    int 21h
    jc ErrorSkaitant
    jmp BeErrorSkaitant

ErrorSkaitant:
    call PrintinamPavad
    lea dx, SkaitError
    mov ah, 09h
    int 21h
		
    mov ax,4C02h      ; error nr.2
    int 21h
	
BeErrorSkaitant:
    cmp ax, 0
    jnz BeErrorTuscioFailo
ErrorTuscioFailo:
    call PrintinamPavad
    lea dx, TusciasError
    mov ah, 09h
    int 21h

    mov ax, 4C03h
    int 21h
BeErrorTuscioFailo:
    ret
SkaitFaila endp
	
	
;======Uzdarinejam faila=============

UzdFaila proc
    mov bx, Handlas
    mov ah, 3Eh     
    int 21h
    ret
UzdFaila endp
	
	
	
	


PrintinamPavad proc
    lea bx, [bp]
    mov ah, 02h
PavadLoopas:    
    mov dl, [bx]    
    inc bx
    cmp dl, 0
    je LoopPabaig
    int 21h
    jmp PavadLoopas
LoopPabaig:
    ret
PrintinamPavad endp
	
	
;=============hex dump'as==========================

HexDumpas proc
    mov charcountas, 0
    
    lea bx, Bufferis
    mov cx, CharSkait
SkaitBaita:
    cmp charcountas, 0
    jne BeLinCount
    call LinCount
BeLinCount:
    xor ax, ax
    xor dx, dx
    mov ax, [bx]
    push cx
    xor cx, cx    
convert:
    div hex
    push dx
    inc cx
    cmp cx, 2
    jnz convert
    
printloopas:
    pop dx
    cmp dx, 0Ah
    jl integer
    add dl, 7    
integer:
    add dl, 30h
    mov ah, 02h
    int 21h
    loop printloopas
    
    mov dl, ' '
    int 21h

    inc charcountas
    inc DabarPozic

    cmp charcountas, 16
    jl KitasBaitas
    

endline:    
    call printbufferi
    mov charcountas, 0
    
KitasBaitas:    
    pop cx
    inc bx
    loop SkaitBaita

    call PrintTarpus   
    call printbufferi
    call LinCount
    lea dx, naujalinija
    mov ah, 09h
    int 21h
    mov DabarPozic, 0
    ret
HexDumpas endp

;======Print teksto bufferi==============

printbufferi proc
    cmp charcountas, 0
    jz SkipinamPrint
    lea di, Bufferis
    add di, [DabarPozic]
    sub di, [charcountas]
    mov dl, '|'
    int 21h
    
    mov cx, [charcountas]
PrintLinija:
    mov dl, [di]
    cmp dl, 0Ah
    je replacinam
    cmp dl, 0Dh
    je replacinam
    jmp SkipinamNaujaLinija
replacinam:
    mov dl, ' '
SkipinamNaujaLinija:
    int 21h
    inc di
    loop PrintLinija
    
    mov dl, '|'
    int 21h
    
    lea dx, naujalinija
    mov ah, 09h
    int 21h
SkipinamPrint:    
    ret
printbufferi endp

;=========Liniju counter'is=========
LinCount proc
    push bx
    mov ax, DabarPozic
    lea si, LinNrBuff
    mov bl, '0'
    mov bh, 0

Isvalom:
    mov [si], bl
    inc si
    inc bh
    cmp bh, 8
    jl Isvalom

    lea si, LinNrBuffEnd
iHexa:
    xor dx, dx
    div hex
    cmp dl, 0Ah
    jl integer0
    add dl, 7h    
integer0:
    add dl, 30h
    dec si
    mov [si], dl
    cmp al, 0
    jg iHexa

    lea dx, LinNrBuff
    mov ah, 9h
    int 21h
    
    pop bx
    
    ret
LinCount endp

;==================print tarpus jei reikia

PrintTarpus proc
    cmp charcountas, 0
    jz SkipinamPrintingSpaces
    mov ax, [hex]
    sub ax, charcountas
    mul [trys]        
    mov cx, ax
    mov dl, ' '
    mov ah, 02h
    
TarpuLoopas:            ; jei reikia
    int 21h    
    loop TarpuLoopas
SkipinamPrintingSpaces:
    ret
PrintTarpus endp
	
end main

